/* zp14c.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__141 = 141;

/* Subroutine */ int zp14c_c(complex *a, complex *b, complex *c__,
        complex *root1, complex *root2, integer *ierr)
{
    /* Initialized data */

    static real sys063 = 2.f;
    static real sys065 = .6931472f;
    static real zero = 0.f;
    static real half = .5f;
    static real sys059 = 3.4e38f;

    /* System generated locals */
    real r__1, r__2, r__3, r__4;
    doublereal d__1;
    complex q__1;
    static complex equiv_10[1], equiv_11[1], equiv_12[1], equiv_13[1], 
            equiv_14[1];

    /* Builtin functions */
    void c_div(complex *, complex *, complex *);
    double log(doublereal), pow_ri(real *, integer *);
    void c_sqrt(complex *, complex *);

    /* Local variables */
    static real temp;
    static doublereal d__;
    static real scale;
#define a0 (equiv_10)
#define b0 (equiv_11)
#define c0 (equiv_12)
    static doublereal d1;
    extern /* Subroutine */ int utzp10_c(integer *, integer *);
#define aa ((real *)equiv_10)
#define bb ((real *)equiv_11)
#define cc ((real *)equiv_12)
#define ai ((real *)equiv_10 + 1)
#define bi ((real *)equiv_11 + 1)
#define ci ((real *)equiv_12 + 1)
    static doublereal di;
#define ar ((real *)equiv_10)
#define br ((real *)equiv_11)
#define cr ((real *)equiv_12)
    static doublereal dr;
    static integer is;
#define zl (equiv_14)
#define zs (equiv_13)
#define zla ((real *)equiv_14)
#define zsa ((real *)equiv_13)
#define zli ((real *)equiv_14 + 1)
#define zsi ((real *)equiv_13 + 1)
#define zlr ((real *)equiv_14)
#define zsr ((real *)equiv_13)

    *ierr = 0;
    a0->r = a->r, a0->i = a->i;
    q__1.r = -b->r, q__1.i = -b->i;
    b0->r = q__1.r, b0->i = q__1.i;
    c0->r = c__->r, c0->i = c__->i;
    if (*ar != zero || *ai != zero) {
        goto L1;
    }
    *ierr = 65;
    q__1.r = sys059, q__1.i = zero;
    zl->r = q__1.r, zl->i = q__1.i;
    q__1.r = -zl->r, q__1.i = -zl->i;
    zs->r = q__1.r, zs->i = q__1.i;
    if (*br == zero && *bi == zero) {
        goto L7;
    }
    *ierr = 66;
    c_div(&q__1, c0, b0);
    zs->r = q__1.r, zs->i = q__1.i;
    goto L7;
L1:
    if (*cr != zero || *ci != zero) {
        goto L2;
    }
    q__1.r = zero, q__1.i = zero;
    zs->r = q__1.r, zs->i = q__1.i;
    goto L6;
L2:
/* Computing MAX */
    r__1 = abs(*ar), r__2 = abs(*ai);
/* Computing MAX */
    r__3 = abs(*cr), r__4 = abs(*ci);
    is = ((real)log((real)(max(r__1,r__2))) +
            (real)log((real)(max(r__3,r__4))) + sys065) / (sys065 + sys065);
    scale = (real)pow_ri(&sys063, &is);
/* Computing MAX */
    r__1 = abs(*br), r__2 = abs(*bi);
    temp = max(r__1,r__2);
    d1 = (doublereal) temp;
    d__ = d1 + scale;
    d__ -= d1;
    if ((real) d__ == zero) {
        goto L5;
    }
    d__ = d1 + scale;
    d__ -= scale;
    if ((real) d__ != zero) {
        goto L3;
    }
    *br = zero;
    *bi = zero;
    goto L4;
L3:
    *br = *br / scale * half;
    *bi = *bi / scale * half;
L4:
    *ar /= scale;
    *ai /= scale;
    *cr /= scale;
    *ci /= scale;
/* Computing 2nd power */
    d__1 = (doublereal) (*br);
    dr = d__1 * d__1;
    di = (doublereal) (*bi) * ((doublereal) (*br) * 2.);
/* Computing 2nd power */
    d__1 = (doublereal) (*bi);
    r__1 = (real) (dr - d__1 * d__1 - (doublereal) (*ar) * (doublereal) (*cr) 
            + (doublereal) (*ai) * (doublereal) (*ci));
    r__2 = (real) (di - (doublereal) (*ai) * (doublereal) (*cr) -
             (doublereal) (*ar) * (doublereal) (*ci));
    q__1.r = r__1, q__1.i = r__2;
    zs->r = q__1.r, zs->i = q__1.i;
    c_sqrt(&q__1, zs);
    zs->r = q__1.r, zs->i = q__1.i;
    if ((doublereal) (*zsr) * (doublereal) (*br) + (doublereal) (*zsi) *
            (doublereal) (*bi) <= zero) {
        q__1.r = -zs->r, q__1.i = -zs->i;
        zs->r = q__1.r, zs->i = q__1.i;
    }
    q__1.r = b0->r + zs->r, q__1.i = b0->i + zs->i;
    b0->r = q__1.r, b0->i = q__1.i;
L5:
    c_div(&q__1, c0, b0);
    zs->r = q__1.r, zs->i = q__1.i;
L6:
    c_div(&q__1, b0, a0);
    zl->r = q__1.r, zl->i = q__1.i;
L7:
    root1->r = zs->r, root1->i = zs->i;
    root2->r = zl->r, root2->i = zl->i;
    if (*ierr != 0) {
        utzp10_c(ierr, &c__141);
    }
    return 0;
} /* zp14c_c */

#undef zsr
#undef zlr
#undef zsi
#undef zli
#undef zsa
#undef zla
#undef zs
#undef zl
#undef cr
#undef br
#undef ar
#undef ci
#undef bi
#undef ai
#undef cc
#undef bb
#undef aa
#undef c0
#undef b0
#undef a0
